---
title: DRM and authentication
slug: Plugins/Flash_to_HTML5/Video/DRM_and_authentication
tags:
  - Authentication
  - DRM
  - Flash
  - HTML
  - Video
  - credential management
  - digital rights management
---
<p>{{PreviousMenuNext("Plugins/Flash_to_HTML5/Video/File_format_conversion", "Plugins/Flash_to_HTML5/Video/Advertising", "Plugins/Flash_to_HTML5/Video")}}</p>

<p class="summary">If your media requires authentication/rights to access, you'll need to work out how to hook up the necessary digital rights management and authentication mechanisms.</p>

<p>You can either work directly with the listed tools and technologies for DRM, or through a third-party vendor such as <a href="https://www.brightcove.com/en/online-video-platform/content-protection-encryption-drm">Brightcove</a>, <a href="https://www.widevine.com/">Google</a> or <a href="https://www.adobe.com/uk/marketing-cloud/primetime/digital-rights-management.html">Adobe</a>. The advantage of using a third-party vendor's system is that generally they will provide or assist with code for checking which platform the user is on, coordinating with the relevant key system for that platform to handle the DRM, etc.</p>

<h2 id="What_is_needed_for_digital_rights_management">What is needed for digital rights management?</h2>

<p>There are a number of components involved in digital rights management (DRM) on the web:</p>

<ul>
 <li>A combination of browser and video player that support the <a href="/en-US/docs/Web/API/Encrypted_Media_Extensions_API">Encrypted Media Extensions API</a> (EME). EME is a JavaScript API that coordinates the different moving parts involved in DRM. (See the <a href="/en-US/docs/Plugins/Flash_to_HTML5/Video#Browser_support">browser support tables </a>for more information.) An example player that supports EME is <a href="https://github.com/google/shaka-player">Google's Shaka player</a>. (See <a href="https://shaka-player-demo.appspot.com/docs/api/tutorial-welcome.html">Welcome to Shaka Player</a> for a series of tutorials.) EME allows you to reuse encrypted assets across many HTML5 platforms.</li>
 <li>A packaging service to encrypt your media. Your media needs to be encrypted to work with an EME-supporting player. HTML5 video can be encrypted once using the ISO BMFF/CENC format and streamed to many browser, mobile, and consumer electronics platforms, saving critical asset storage and maintenance costs. One tool that can satisfy these needs is <a href="https://github.com/google/shaka-packager">Shaka Packager</a>. (See <a href="https://storage.googleapis.com/wvdocs/Widevine_DRM_Encoding_and_Packaging.pdf">Widevine Encoding and Packaging</a> and <a href="https://storage.googleapis.com/wvdocs/Widevine_DRM_Using_Shaka_Packager_and_Player.pdf">Widevine Using the Shaka Packager and Player</a> for useful usage information.)</li>
 <li>A DRM service (key system) that generates keys to be used in license requests.</li>
 <li>A content decryption module (CDM) for client-side playback. This component handles retrieving keys, generating license requests by sending keys to license servers, etc. EME provides an interface for interacting with CDMs, though it does not define any itself.</li>
</ul>

<p>You can find a lot more detail about how the system works in <a href="https://developers.google.com/web/fundamentals/media/eme">What is EME?</a></p>

<h3 id="DRM_services">DRM services</h3>

<p>Unlike Flash, the web requires you to use different digital rights management services depending upon which OS/browser your app is running on. The primary DRM services (key systems) for the web are:</p>

<ul>
 <li><a href="https://www.widevine.com/">Google Widevine</a></li>
 <li><a href="https://www.microsoft.com/playready/">Microsoft PlayReady</a></li>
 <li><a href="https://developer.apple.com/streaming/fps/">Apple FairPlay</a></li>
</ul>

<p>In general, Widevine is supported by Firefox, Chrome, and Opera, PlayReady is supported by IE/Edge, and FairPlay is supported by Safari. Check out our <a href="/en-US/docs/Plugins/Flash_to_HTML5/Video#Browser_support">Browser support tables</a> for more details.</p>

<h2 id="Authentication">Authentication</h2>

<p>If you want users to authenticate before they can access your content, you could build your own authentication system, or use a single toolkit like <a href="https://www.adobe.com/uk/marketing-cloud/primetime/digital-rights-management.html">Adobe Primetime</a> to handle both your authentication and DRM needs in one place.</p>

<p>If you want to create your own system, it is worth taking a look at the <a href="/en-US/docs/Web/API/Credential_Management_API">Credential Management API</a>, which is a dedicated API to faciliate authentication.</p>
